<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Mail\Mailables\Content;
use Illuminate\Mail\Mailables\Envelope;
use Illuminate\Queue\SerializesModels;
use Barryvdh\DomPDF\Facade\Pdf;

class EnglishTestMail extends Mailable
{
    use Queueable, SerializesModels;
    private $data = [];

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($data)
    {
        //
        $this->data = $data;
    }
    /**
     * Get the message envelope.
     *
     * @return \Illuminate\Mail\Mailables\Envelope
     */
    public function envelope()
    {
        return new Envelope(
            subject: 'Cambridge English Test Results!',
        );
    }

    /**
     * Get the message content definition.
     *
     * @return \Illuminate\Mail\Mailables\Content
     */
    public function content()
    {

        return new Content(
            view: 'emails.englishTest.englishTestMail',
        );

    }
    public function build()
    {
        $pdf = PDF::loadView('emails.englishTest.englishTestCert', ['data' => $this->data]);

        return $this->from('englishTest@advisecampus.com', 'AdviseCampus')
            ->subject($this->data['subject'])
            ->view('emails.englishTest.englishTestMail')
            ->with('data', $this->data)
            ->attachData($pdf->output(), 'Certificate.pdf');
    }

    /**
     * Get the attachments for the message.
     *
     * @return array
     */
    public function attachments()
    {
        return [
        ];
    }
}
